/* 
 * Copyright (c) 2010 Microsoft Corporation and Inria. 
 * Contributors: Fanny Chevalier and Pierre Dragicevic. 
 * 
 * You may distribute under the terms of either the CeCILL-B License or the 
 * CeCILL version 2 License.
 */
package fr.aviz.diffanimation;

import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;

import fr.aviz.diff.methods.BestDiff;
import fr.aviz.diff.methods.CleanRatcliffDiff;
import fr.aviz.diff.methods.MyersDiff;
import fr.aviz.diff.methods.PonsDiff;
import fr.aviz.diff.methods.PonsDiffNoMoves;
import fr.aviz.diff.methods.RatcliffDiff;
import fr.aviz.diffanimation.Document.Version;

public class Settings {
	/* Font settings constants */
	public static final String[] TEXT_FONT_NAMES = new String[] {
		"Proportional",
		"Monospaced"
	};
	public static final Font[] TEXT_FONTS = new Font[] {
		new Font("Helvetica", Font.PLAIN, 14),
		new Font("Courier New", Font.PLAIN, 14)
	};
	public final float LINE_SPACING = 1.3f;
	
	/* Diff method */
	public Class diffMethod = PonsDiff.class;//PonsDiff.class;//BestDiff.class;
	
	/* Font & layout settings -- internal */
	public int textFontIndex = 0;
	public FontRenderContext fontRenderContext = null;
	public TextLayout nominalTextLayout = null;
	public float lineWidth;
	public float lineHeight;
	public float leading;
	public float baseline;
	public float ascent;
	
	
	/* Animation settings */
	public boolean animationEnabled = true;
	public double speed = 1;
	public boolean autoSpeed = true;
	public boolean colors = true;
	public boolean transparency = false;
	public boolean highlights = true;
	public boolean overviewHighlights = true;
	public boolean transientHighlights = false;
	public int overviewStyle = 0;
	public Graphics2D defaultGraphics;
	public SpeedNormalizer speedNormalizer;
	
	// To remove
	public Version vstart = Version.V1;
	public Version vend = Version.V2;
	
	public Settings() {
	};
}