/* 
 * Copyright (c) 2010 Microsoft Corporation and Inria. 
 * Contributors: Fanny Chevalier and Pierre Dragicevic. 
 * 
 * You may distribute under the terms of either the CeCILL-B License or the 
 * CeCILL version 2 License.
 */
package fr.aviz.wikidiffparser;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.BufferedReader;

import org.xml.sax.XMLReader;
import org.xml.sax.InputSource;
import org.xml.sax.helpers.XMLReaderFactory;
//import org.xml.sax.ContentHandler;


//import org.xml.sax.helpers.DefaultHandler;
//import org.xml.sax.Attributes;

public class WikiDiffParser {
  
	public static void main (String args[]) throws Exception 
	{
		ContentHandler handler;
		handler = new ContentHandler();
		
		XMLReader xr = XMLReaderFactory.createXMLReader();
		xr.setContentHandler(handler);


		// Parse the standard input if no argument
		if(args.length == 1) {
			xr.parse("data/");
			writeResult("data/wikistats/overallStats.txt", handler.overallEditions());
			writeResult("data/wikistats/insertionStats.txt", handler.getInsertionStats());
			writeResult("data/wikistats/insertionDistrib.txt", handler.getInsertionDistribution());
			writeResult("data/wikistats/deletionStats.txt", handler.getDeletionStats());
			writeResult("data/wikistats/deletionDistrib.txt", handler.getDeletionDistribution());
			writeResult("data/wikistats/moveStats.txt", handler.getMoveStats());
			writeResult("data/wikistats/moveDistrib.txt", handler.getMoveDistribution());
			writeResult("data/wikistats/insertionSizeStats.txt", handler.getSizeInsertionStats());
			writeResult("data/wikistats/insertionSizeDistrib.txt", handler.getSizeInsertionDistribution());
			writeResult("data/wikistats/deletionSizeStats.txt", handler.getSizeDeletionStats());
			writeResult("data/wikistats/deletionSizeDistrib.txt", handler.getSizeDeletionDistribution());
			writeResult("data/wikistats/moveSizeStats.txt", handler.getSizeMoveStats());
			writeResult("data/wikistats/moveSizeDistrib.txt", handler.getSizeMoveDistribution());
		}	
	}
	
	private static void writeResult(String file, String str) throws Exception{
		BufferedWriter outfile = new BufferedWriter(new FileWriter(file));    
		outfile.write(str);  
		outfile.close();   
	}
}
